#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

GtkWidget *text1, *text2, *text3, *text4;
void attiva(void);

int main( int   argc, char *argv[] )
{
	GtkWidget *window, *button, *label, *hbox1, *hbox2, *hbox3, *hbox4, *hbox5, *vbox;
	//GtkWidget *text1, *text2, *text3, *text4;

	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	g_signal_connect (G_OBJECT (window), "destroy",G_CALLBACK (gtk_main_quit),NULL);

	vbox = gtk_vbox_new (FALSE, 5);
	gtk_window_set_title (GTK_WINDOW (window), "OpenVPN Gui");
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_container_set_border_width (GTK_CONTAINER (window), 5);

	hbox1 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox1, FALSE, FALSE, 0);
	label = gtk_label_new("Host Locale Privato     ");
	gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (label) ,GTK_JUSTIFY_RIGHT);
	text1 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (hbox1), text1, FALSE, FALSE, 0);

	hbox2 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox2, FALSE, FALSE, 0);
	label = gtk_label_new("Host Remoto Privato   ");
	gtk_box_pack_start (GTK_BOX (hbox2), label, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (label) ,GTK_JUSTIFY_RIGHT);
	text2 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (hbox2), text2, FALSE, FALSE, 0);

	hbox3 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox3, FALSE, FALSE, 0);
	label = gtk_label_new("Host Remoto Pubblico");
	gtk_box_pack_start (GTK_BOX (hbox3), label, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (label) ,GTK_JUSTIFY_RIGHT);
	text3 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (hbox3), text3, FALSE, FALSE, 0);

	hbox4 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox4, FALSE, FALSE, 0);
	label = gtk_label_new("Locazione della key    ");
	gtk_box_pack_start (GTK_BOX (hbox4), label, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (label) ,GTK_JUSTIFY_RIGHT);
	text4 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (hbox4), text4, FALSE, FALSE, 0);

	hbox5 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox5, FALSE, FALSE, 0);
	button = gtk_button_new_with_label ("OK");
	gtk_box_pack_start (GTK_BOX (hbox5), button, FALSE, FALSE, 0);
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (attiva), NULL);

	gtk_widget_show_all(window);

	gtk_main ();
	return 0;
}

void attiva(void)
{
	char *start = "--remote";
	char *middle1 = "--dev";
	char *middle2 = "tun1";
	char *middle3 = "--ifconfig";
	char *end = "--verb 5 --secret";
	//char comando[1024];
	int pid;
	
	//sprintf(comando, "%s%s%s%s %s%s%s\n", start, gtk_entry_get_text(GTK_ENTRY(text3)), middle, gtk_entry_get_text(GTK_ENTRY(text1)), gtk_entry_get_text(GTK_ENTRY(text2)), end, gtk_entry_get_text(GTK_ENTRY(text4)));
	
	
	pid = fork();
	if (!pid)
		execlp("openvpn","openvpn",start,gtk_entry_get_text(GTK_ENTRY(text3)),middle1,middle2,middle3,gtk_entry_get_text(GTK_ENTRY(text1)),gtk_entry_get_text(GTK_ENTRY(text2)), end,gtk_entry_get_text(GTK_ENTRY(text4)),NULL);
	
}
